/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * 
 */
package jp.mosp.kintai.payroll.action;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.CsvUtil;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.dto.MKihonDto;
import jp.mosp.kintai.payroll.dao.KdWorkDao;
import jp.mosp.kintai.payroll.dto.KdWorkDto;
import jp.mosp.kintai.payroll.vo.WorkCompileExportCardVo;
import jp.mosp.payroll.dao.MKintaiDao;
import jp.mosp.payroll.dto.MKintaiDto;

/**
 * @author nakamura
 *
 */
public class WorkCompileExportCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_SHOW	= "S1230";
	private static final String	CMD_EXPORT	= "S1231";
	
	// 定数
	private static final int	NUM_2010	= 2010;
	

	/**
	 * コンストラクター
	 */
	public WorkCompileExportCardAction() {
		super();
	}
	
	/* (非 Javadoc)
	 * @see jp.mosp.common.common.ActionInterface#action()
	 */
	public void action() throws Exception {
		// VOの準備
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (CMD_SHOW.equals(cmd)) {
			// 表示
			show();
		} else if (CMD_EXPORT.equals(cmd)) {
			// エクスポート
			export();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new WorkCompileExportCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// ユーザ情報の取得
		getInfo(user.getUserId());
		// プルダウンの設定
		WorkCompileExportCardVo vo = (WorkCompileExportCardVo)getVo();
		vo.aryPltSection = getSectionArrayAll();
		vo.aryPltYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), 9, 1);
		vo.aryPltMonth = StringUtil.getMonthArray();
		vo.aryPltWorkTable = getWorkTableArray();
		vo.aryOldYear = StringUtil.getYearArray(NUM_2010, 3, 0);
		if ((MospUtility.getYear(DateUtil.getSystemDate()) - NUM_2010) != 0) {
			vo.aryNewYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), MospUtility
				.getYear(DateUtil.getSystemDate())
					- NUM_2010, 1);
		} else {
			vo.aryNewYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), 0, 1);
		}
		vo.aryOldMonth = getOldMonthArray();
		vo.aryNewMonth = getNewMonthArray();
	}
	
	/**
	 * 新旧勤怠集計テーブル選択プルダウン
	 * @return		新旧勤怠テーブル
	 */
	private String[][] getWorkTableArray() {
		String[][] arrayWorkTable = new String[2][2];
		arrayWorkTable[0][0] = "0";
		arrayWorkTable[0][1] = "〜2010年3月まで";
		arrayWorkTable[1][0] = "1";
		arrayWorkTable[1][1] = "2010年4月〜";
		return arrayWorkTable;
	}
	
	/**
	 * 旧勤怠集計テーブル選択時月プルダウン
	 * @return		1〜3月プルダウン
	 */
	private String[][] getOldMonthArray() {
		String[][] arrayOldMonth = new String[3][2];
		for (int i = 0; i < 3; i++) {
			arrayOldMonth[i][0] = String.valueOf(i + 1);
			arrayOldMonth[i][1] = String.valueOf(i + 1);
		}
		return arrayOldMonth;
	}
	
	/**
	 * 新勤怠集計テーブル選択時月プルダウン
	 * @return		4〜12月プルダウン
	 */
	private String[][] getNewMonthArray() {
		String[][] arrayNewMonth = new String[9][2];
		for (int i = 3; i < 12; i++) {
			arrayNewMonth[i - 3][0] = String.valueOf(i + 1);
			arrayNewMonth[i - 3][1] = String.valueOf(i + 1);
		}
		return arrayNewMonth;
	}
	
	@Override
	protected void show() throws Exception {
		WorkCompileExportCardVo vo = (WorkCompileExportCardVo)getVo();
		// 初期値
		vo.setDefaultValues();
		Date todayDate = DateUtil.getSystemDate();
		vo.setPltSection(userBasis.getSCode());
		// 開始年月日
		vo.setPltStartYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltStartMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		// 終了年月日
		vo.setPltEndYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltEndMonth(String.valueOf(MospUtility.getMonth(todayDate)));
	}
	
	/**
	 * エクスポート
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void export() throws Exception {
		WorkCompileExportCardVo vo = (WorkCompileExportCardVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// 妥当性確認
		vo.validate();
		// 社員コードリスト
		List<String> kCodeList = new ArrayList<String>();
		// 開始年月
		String startSikyuNen = vo.getPltStartYear();
		String startSikyuTuki = vo.getPltStartMonth();
		// 終了年月
		String endSikyuNen = vo.getPltEndYear();
		String endSikyuTuki = vo.getPltEndMonth();
		// 社員コードが入力されている場合
		if (StringUtil.isNotNull(vo.getTxtKCode())) {
			kCodeList.add(vo.getTxtKCode());
		} else {
			List<MKihonDto> mkihonList = part().human().getMKihonDao().findForSection(vo.getPltSection(),
					DateUtil.convDateToInteger(DateUtil.getFirstDateOfMonth(startSikyuNen, startSikyuTuki)),
					DateUtil.convDateToInteger(DateUtil.getLastDateOfMonth(endSikyuNen, endSikyuTuki)));
			for (MKihonDto dto : mkihonList) {
				kCodeList.add(dto.getKCode());
			}
		}
		// 出力ファイル名
		StringBuffer fileName = new StringBuffer();
		fileName.append("Work");
		fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		if (StringUtil.isNotNull(vo.getTxtKCode())) {
			fileName.append(vo.getTxtKCode());
			fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		} else {
			fileName.append(vo.getPltSection());
			fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		}
		fileName.append(startSikyuNen + "-" + startSikyuTuki);
		fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		fileName.append(endSikyuNen + "-" + endSikyuTuki);
		fileName.append(CommonConst.FILE_COMMON_CSV);
		request.setAttribute(MospConst.ATT_FILE_NAME, fileName.toString());
		// 出力ファイルオブジェクト
		request.setAttribute(MospConst.ATT_FILE_OBJECT, makeWorkExportData(vo, kCodeList, startSikyuNen,
				startSikyuTuki, endSikyuNen, endSikyuTuki));
		// 処理シーケンスを発行しない。
		setNeedProcSeq(false);
	}
	
	/**
	 * エクスポートデータ生成
	 * @param vo			勤怠エクスポートVO
	 * @param kCodeList		対象社員コードリスト
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索開始月
	 * @param endSikyuNen 検索終了年
	 * @param endSikyuTuki 検索終了月
	 * @return	勤怠データ（CSV）
	 * @throws Exception 	例外処理が発生した場合
	 */
	private StringBuffer makeWorkExportData(WorkCompileExportCardVo vo, List<String> kCodeList, String startSikyuNen,
			String startSikyuTuki, String endSikyuNen, String endSikyuTuki) throws Exception {
		// 帳票作成準備
		StringBuffer sb = new StringBuffer();
		// ヘッダー情報設定
		sb.append(CsvUtil.toCsvLine(part().compile().getNewWorkCsvHeader()));
		if (vo.getPltWorkTable().equals("0")) {
			// データ追記
			sb.append(appendOldData(kCodeList, startSikyuNen, startSikyuTuki, endSikyuNen, endSikyuTuki));
		} else if (vo.getPltWorkTable().equals("1")) {
			// データ追記
			sb.append(appendNewData(kCodeList, startSikyuNen, startSikyuTuki, endSikyuNen, endSikyuTuki));
		}
		return sb;
	}
	
	/**
	 * 旧勤怠情報データ生成
	 * @param kCodeList		対象社員コードリスト
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索開始月
	 * @param endSikyuNen 検索開始年
	 * @param endSikyuTuki 検索開始月
	 * @return	旧勤怠情報データ
	 * @throws Exception 	例外処理が発生した場合
	 */
	private StringBuffer appendOldData(List<String> kCodeList, String startSikyuNen, String startSikyuTuki,
			String endSikyuNen, String endSikyuTuki) throws Exception {
		StringBuffer sb = new StringBuffer();
		VariousUtil.sortList(kCodeList, new ComparatorKCode());
		for (String kCode : kCodeList) {
			List<MKintaiDto> kintaiList = getKintaiInfoList(kCode, startSikyuNen, startSikyuTuki, endSikyuNen,
					endSikyuTuki);
			for (MKintaiDto dto : kintaiList) {
				sb.append(CsvUtil.toCsvLine(toCsvOldDataArray(dto)));
			}
		}
		return sb;
	}
	
	/**
	 * 新勤怠情報データ生成
	 * @param kCodeList		対象社員コードリスト
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索開始月
	 * @param endSikyuNen 検索開始年
	 * @param endSikyuTuki 検索開始月
	 * @return	新勤怠情報データ
	 * @throws Exception 	例外処理が発生した場合
	 */
	private StringBuffer appendNewData(List<String> kCodeList, String startSikyuNen, String startSikyuTuki,
			String endSikyuNen, String endSikyuTuki) throws Exception {
		StringBuffer sb = new StringBuffer();
		VariousUtil.sortList(kCodeList, new ComparatorKCode());
		for (String kCode : kCodeList) {
			List<KdWorkDto> workList = getWorkInfoList(kCode, startSikyuNen, startSikyuTuki, endSikyuNen, endSikyuTuki);
			for (KdWorkDto dto : workList) {
				sb.append(CsvUtil.toCsvLine(toCsvNewDataArray(dto)));
			}
		}
		return sb;
	}
	
	/**
	 * 旧勤怠情報リスト取得
	 * @param kCode			対象社員コード
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索開始月
	 * @param endSikyuNen 検索開始年
	 * @param endSikyuTuki 検索開始月
	 * @return	検索結果(DTOのList)
	 * @throws Exception	例外処理が発生した場合
	 */
	public List<MKintaiDto> getKintaiInfoList(String kCode, String startSikyuNen, String startSikyuTuki,
			String endSikyuNen, String endSikyuTuki) throws Exception {
		MKintaiDao dao = new MKintaiDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		return dao.findForCondition(kCode, Integer.parseInt(startSikyuNen), Integer.parseInt(startSikyuTuki), Integer
			.parseInt(endSikyuNen), Integer.parseInt(endSikyuTuki), Integer.parseInt(endSikyuNen)
				- Integer.parseInt(startSikyuNen));
	}
	
	/**
	 * 新勤怠情報リスト取得
	 * @param kCode			対象社員コード
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索開始月
	 * @param endSikyuNen 検索開始年
	 * @param endSikyuTuki 検索開始月
	 * @return	検索結果(DTOのList)
	 * @throws Exception	例外処理が発生した場合
	 */
	public List<KdWorkDto> getWorkInfoList(String kCode, String startSikyuNen, String startSikyuTuki,
			String endSikyuNen, String endSikyuTuki) throws Exception {
		KdWorkDao dao = new KdWorkDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		return dao.findForCondition(kCode, Integer.parseInt(startSikyuNen), Integer.parseInt(startSikyuTuki), Integer
			.parseInt(endSikyuNen), Integer.parseInt(endSikyuTuki), Integer.parseInt(endSikyuNen)
				- Integer.parseInt(startSikyuNen));
	}
	
	/**
	 * CSVファイル用文字列変換
	 * @param dto	対象勤怠情報DTO
	 * @return	CSVファイル用配列
	 */
	public static String[] toCsvOldDataArray(MKintaiDto dto) {
		List<String> dataList = new LinkedList<String>();
		// 社員コード
		dataList.add(dto.getKCode());
		// 支給年月
		dataList.add(dto.getSikyuYM());
		// 支給年
		dataList.add(String.valueOf(dto.getSNen()));
		// 支給月
		dataList.add(String.valueOf(dto.getSTuki()));
		// 支給日
		dataList.add(String.valueOf(dto.getSHi()));
		// 出勤日数
		dataList.add(String.valueOf(dto.getSNissu()));
		// 出勤回数
		dataList.add(String.valueOf(dto.getSKaisu()));
		// 勤務時間
		dataList.add(String.valueOf(dto.getKinmuJi()));
		// 休憩時間
		dataList.add(String.valueOf(dto.getKyukeiJi()));
		// 有休
		dataList.add(String.valueOf(dto.getYukyu()));
		// 特別休暇
		dataList.add(String.valueOf(dto.getTokuKyu()));
		// 一般欠勤日数
		dataList.add(String.valueOf(dto.getKekkin()));
		// 傷病欠勤日数
		dataList.add(String.valueOf(dto.getSKekkin()));
		// 代替休暇
		dataList.add(String.valueOf(dto.getDaiKyu()));
		// 振替休暇
		dataList.add(String.valueOf(dto.getFurikae()));
		// 休暇理由6
		dataList.add("0");
		// 休暇理由7
		dataList.add("0");
		// 休暇理由8
		dataList.add("0");
		// 休暇理由9
		dataList.add("0");
		// その他休暇
		dataList.add(String.valueOf(dto.getSonota()));
		// 遅刻早退回数
		dataList.add(String.valueOf(dto.getTiSoKai()));
		// 遅刻早退時間
		dataList.add(String.valueOf(dto.getTiJikan()));
		// 普通残業時間
		dataList.add(String.valueOf(dto.getZaJikan()));
		// 休日出勤時間
		dataList.add(String.valueOf(dto.getKsJikan()));
		// 深夜勤務時間
		dataList.add(String.valueOf(dto.getSnJikan()));
		// 精皆勤手当支給
		dataList.add(String.valueOf(dto.getKaikin()));
		// 食事手当支給回数
		dataList.add(String.valueOf(dto.getSyokujiKaisu()));
		// 1直手当支給回数
		dataList.add(String.valueOf(dto.getCyokuKaisu1()));
		// 2直手当支給回数
		dataList.add(String.valueOf(dto.getCyokuKaisu2()));
		// 3直手当支給回数
		dataList.add(String.valueOf(dto.getCyokuKaisu3()));
		// その他支給回数1
		dataList.add(String.valueOf(dto.getHokaKaisu1()));
		// その他支給回数2
		dataList.add(String.valueOf(dto.getHokaKaisu2()));
		// その他支給回数3
		dataList.add(String.valueOf(dto.getHokaKaisu3()));
		// その他支給回数4
		dataList.add(String.valueOf(dto.getHokaKaisu4()));
		// その他支給回数5
		dataList.add(String.valueOf(dto.getHokaKaisu5()));
		// 支払申請額
		dataList.add(String.valueOf(dto.getSinseiGaku()));
		// 1.00割増
		dataList.add(String.valueOf(dto.getWarimasi1()));
		// 平日時間外
		dataList.add("0");
		// 所定休日時間外
		dataList.add("0");
		// 月60時間超過平日時間外
		dataList.add("0");
		// 月60時間超過所定休日時間外
		dataList.add("0");
		// 時間単位年休取得時間
		dataList.add("0");
		// 時間外時間代替休暇取得日数
		dataList.add("0.0");
		// 修正フラグ
		dataList.add("0");
		// 登録日
		dataList.add(DateUtil.getDateTime(dto.getInsertDate()));
		// 登録者
		dataList.add(dto.getInsertUser());
		// 更新日
		dataList.add(DateUtil.getDateTime(dto.getUpdateDate()));
		// 更新者
		dataList.add(dto.getInsertUser());
		return StringUtil.listToArray(dataList);
	}
	
	/**
	 * CSVファイル用文字列変換
	 * @param dto	対象勤怠情報DTO
	 * @return	CSVファイル用配列
	 */
	public static String[] toCsvNewDataArray(KdWorkDto dto) {
		List<String> dataList = new LinkedList<String>();
		// 社員コード
		dataList.add(dto.getKCode());
		// 支給年月
		dataList.add(dto.getSikyuYm());
		// 支給年
		dataList.add(String.valueOf(dto.getSNen()));
		// 支給月
		dataList.add(String.valueOf(dto.getSTuki()));
		// 支給日
		dataList.add(String.valueOf(dto.getSHi()));
		// 出勤日数
		dataList.add(String.valueOf(dto.getSNissu()));
		// 出勤回数
		dataList.add(String.valueOf(dto.getSKaisu()));
		// 勤務時間
		dataList.add(String.valueOf(dto.getKinmuJi()));
		// 休憩時間
		dataList.add(String.valueOf(dto.getKyukeiJi()));
		// 有休
		dataList.add(String.valueOf(dto.getYukyu()));
		// 特別休暇
		dataList.add(String.valueOf(dto.getTokukyu()));
		// 一般欠勤日数
		dataList.add(String.valueOf(dto.getKekkin()));
		// 傷病欠勤日数
		dataList.add(String.valueOf(dto.getSKekkin()));
		// 代替休暇
		dataList.add(String.valueOf(dto.getDaikyu()));
		// 振替休暇
		dataList.add(String.valueOf(dto.getFurikae()));
		// 休暇理由6
		dataList.add(String.valueOf(dto.getKkRiyuu6()));
		// 休暇理由7
		dataList.add(String.valueOf(dto.getKkRiyuu7()));
		// 休暇理由8
		dataList.add(String.valueOf(dto.getKkRiyuu8()));
		// 休暇理由9
		dataList.add(String.valueOf(dto.getKkRiyuu9()));
		// その他休暇
		dataList.add(String.valueOf(dto.getSonota()));
		// 遅刻早退回数
		dataList.add(String.valueOf(dto.getTiSoKai()));
		// 遅刻早退時間
		dataList.add(String.valueOf(dto.getTiSoJikan()));
		// 普通残業時間
		dataList.add(String.valueOf(dto.getZaJikan()));
		// 休日出勤時間
		dataList.add(String.valueOf(dto.getKsJikan()));
		// 深夜勤務時間
		dataList.add(String.valueOf(dto.getSnJikan()));
		// 精皆勤手当支給
		dataList.add(String.valueOf(dto.getKaikin()));
		// 食事手当支給回数
		dataList.add(String.valueOf(dto.getSyokujiKaisu()));
		// 1直手当支給回数
		dataList.add(String.valueOf(dto.getCyokuKaisu1()));
		// 2直手当支給回数
		dataList.add(String.valueOf(dto.getCyokuKaisu2()));
		// 3直手当支給回数
		dataList.add(String.valueOf(dto.getCyokuKaisu3()));
		// その他支給回数1
		dataList.add(String.valueOf(dto.getHokaKaisu1()));
		// その他支給回数2
		dataList.add(String.valueOf(dto.getHokaKaisu2()));
		// その他支給回数3
		dataList.add(String.valueOf(dto.getHokaKaisu3()));
		// その他支給回数4
		dataList.add(String.valueOf(dto.getHokaKaisu4()));
		// その他支給回数5
		dataList.add(String.valueOf(dto.getHokaKaisu5()));
		// 支払申請額
		dataList.add(String.valueOf(dto.getSinseiGaku()));
		// 1.00割増
		dataList.add(String.valueOf(dto.getWarimasi1()));
		// 平日時間外
		dataList.add(String.valueOf(dto.getWeekDayOverTime()));
		// 所定休日時間外
		dataList.add(String.valueOf(dto.getWeekHolidayOverTime()));
		// 月60時間超過平日時間外
		dataList.add(String.valueOf(dto.getMonthlyOverTime()));
		// 月60時間超過所定休日時間外
		dataList.add(String.valueOf(dto.getMonthlyWeekHoliday()));
		// 時間単位年休取得時間
		dataList.add(String.valueOf(dto.getHourHoliday()));
		// 時間外時間代替休暇取得日数
		dataList.add(String.valueOf(dto.getSubstituteHoliday()));
		// 修正フラグ
		dataList.add(String.valueOf(dto.getAmendFlag()));
		// 登録日
		dataList.add(DateUtil.getDateTime(dto.getInsertDate()));
		// 登録者
		dataList.add(dto.getInsertUser());
		// 更新日
		dataList.add(DateUtil.getDateTime(dto.getUpdateDate()));
		// 更新者
		dataList.add(dto.getInsertUser());
		return StringUtil.listToArray(dataList);
	}
	

	// ソート
	private class ComparatorKCode implements Serializable, Comparator<Object> {
		
		private static final long	serialVersionUID	= -3477068419987991550L;
		

		public int compare(Object o1, Object o2) {
			return o1.toString().compareTo(o2.toString());
		}
		
	}
	
}
